<template>
    <div v-if="forecast" class="forecast">
        <div>Forecast:</div>
        <div v-if="chartdata">
            <temp-format :format="forecast.list[0].format" />
            <line-chart :chart-data="chartdata" :height="150" />
        </div>
        <carousel :perPageCustom="[[768, 4], [1024, 6]]"
                  ref="carousel"
                  :paginationEnabled="false"
                  :navigationEnabled="true"
                  @page-change="slideChanged">
            <slide v-for="(weather,index) in forecast.list"
                   :key="weather.dt">
                <weather :weather="weather" :index="index" />
            </slide>
        </carousel>
    </div>
</template>

<script>
    import Weather from '../dashboard/Weather'
    import LineChart from './LineChart'
    import TempFormat from './TempFormat'
    import { Carousel, Slide } from 'vue-carousel'

    export default {
        name: "Forecast",
        components: {
            TempFormat,
            Weather, Carousel, Slide, LineChart
        },
        props: {
            forecast: {
                type: Object
            }
        },
        data() {
            return {
                slider: {
                    page: null,
                    perPage: null
                },
                chartdata: null
            }
        },
        watch: {
            forecast(val, oldVal) {
                if (oldVal) {
                    this.definePages();
                    this.defineChartData();
                }
            }
        },
        mounted() {
            window.addEventListener('resize', () => {
                this.definePages();
                this.defineChartData();
            })
        },
        methods: {
            slideChanged() {
                this.definePages();
                this.defineChartData();
            },
            defineChartData() {
                const slice = this.forecast.list.slice(
                    this.slider.page*this.slider.perPage,(this.slider.page+1)*this.slider.perPage
                );
                this.chartdata = {labels:[],datasets: [{label: this.forecast.city.name, data: []}]};
                slice.forEach(item => {
                     this.chartdata.labels.push(moment(item.dt*1000).format('HH:mm'));
                     this.chartdata.datasets[0].data.push(item.main.temp);
                });
            },
            definePages() {
                this.slider.page = this.$refs.carousel.currentPage;
                this.slider.perPage = this.$refs.carousel.currentPerPage;
            }
        }
    }
</script>

<style scoped lang="scss">
    .forecast {

        &::v-deep .weather {

            &__temp {
                font-size: 16px;
            }

            &__icon {
                width: 50px;
            }

            .table {
                font-size: 13px;

                td {
                    padding: .5rem;
                }
            }
        }
    }

    .temp-format {
        position: absolute;
    }
</style>